/* 
 * File:   Localization.h
 * Author: myron
 *
 * Created on Štvrtok, 2010, september 9, 10:17
 */

#ifndef LOCALIZATION_H
#define	LOCALIZATION_H

#include "DataTypes.h"
#include <vector>
#include <map>
#include <cv.h>

using namespace std;

class IdDist{
public:
    long id;
    double dist;
};

class FindOnWay{
public:
    Ll pointFound;
    long pointId1;
    long pointId2;
    int pathId;
    int pathPosition;
};

class WayPoint : public Ll {
public:
    vector<long> nextPoints;

    //for searching
    double dist;
    long previous;

    WayPoint(){
        dist = DBL_MAX;
        previous = -1;
    };
    WayPoint(Ll src){
        dist = DBL_MAX;
        previous = -1;
        this->latitude = src.latitude;
        this->longitude = src.longitude;
    };
};

class Path{
public:
    vector<long> points;
};


class BoundsLl{
public:
    double minlat;
    double minlon;
    double maxlat;
    double maxlon;
};

class LocalizationAndPlaning {
public:
    vector<Path > paths;
    map< long, WayPoint> points;
    BoundsLl bounds;

    int guiWidth;
    int guiHeight;

    //Ll destionation;
    long destId;
    vector<int> way;
    //dint curPath;
    long curPoint;
    long wasCurPoint;

    long lastCurPoint;



    long headingPointId;
    Ll lastPosition;

    LocalizationAndPlaning(int guiWidth, int guiHeight);
    virtual ~LocalizationAndPlaning();

    void readMap(char* filename);

    IplImage* getGui();
    IplImage* getGui(Ll point);

    void setDestination(Ll point);//prvate?
    void readDestination(char* filename);

    GpsAngles update( Ll gps);//TODO: , ImuData imu);

    void findWay(vector<long>* usedPoints, long destPoint, long curPoint, double dist, int level);
    void findWay2(long destPoint, long curPoint);

    //bool distCompare(IdDist i, IdDist j);
    Ll reverse(Point location);

private:
    double dist_point_linesegment(double x, double y, double x1, double y1, double x2, double y2, double *nx, double *ny);
    FindOnWay find_on_way(Ll point);
    long add_point_on_way(Ll point);
    Point convert(Ll point);

    vector<long> bestWay;
    double bestDist;
    
    double distance(Ll p1, Ll p2);
    double distance2(Ll p1, Ll p2);
    double wayDistance(vector<long> w);
    
};

#endif	/* LOCALIZATION_H */

